import java.util.Arrays;
import java.util.Scanner;
import java.util.StringTokenizer;

public class AnaliseSentimento {
	
	public static void main(String[] args) {
		Scanner s = new Scanner(System.in);

		String [] positiveWords = s.nextLine().split(" ");
		String [] negativeWords = s.nextLine().split(" ");
		String [] hashtags = s.nextLine().split(" ");
		s.nextLine();

		Arrays.sort(hashtags);

		// [x][0] -> positivo, [x][1] -> negativo
		String [][] autores = new String[hashtags.length][2];
		int [][] humor = new int[hashtags.length][2];

		for ( int i = 0; i < humor.length; i++ ) {
			humor[i][0] = Integer.MIN_VALUE;
			humor[i][1] = Integer.MAX_VALUE;
		}

		String head = s.nextLine();

		while ( !head.equals("END") ) {
			// leitura
			String tweet = s.nextLine();
			s.nextLine();

			// contabilizar o humor
			int positivo = 0, negativo = 0;
			for ( String p : positiveWords )
				positivo += ocorrenciasDe(p, tweet);
			for ( String n : negativeWords )
				negativo += ocorrenciasDe(n, tweet);
			int humorTweet = positivo - negativo;

			// encontra a hashtag
			int indiceHashtag = 0;
			for ( int i = 0; i < hashtags.length; i++ ) {
				if ( tweet.contains(hashtags[i]) ) {
					indiceHashtag = i;
					break;
				}
			}

			if ( humorTweet > humor[indiceHashtag][0] ) {
				humor[indiceHashtag][0] = humorTweet;
				autores[indiceHashtag][0] = head.split(" - ")[1];
			}
			if ( humorTweet < humor[indiceHashtag][1] ) {
				humor[indiceHashtag][1] = humorTweet;
				autores[indiceHashtag][1] = head.split(" - ")[1];
			}

			head = s.nextLine();

		}

		// imprime o autor mais positivo e o mais negativo de cada tema
		for ( int i = 0; i < hashtags.length; i++ ) {
			System.out.println(hashtags[i]);
			System.out.println(autores[i][0]);
			System.out.println(autores[i][1]);
			System.out.println();
		}
	}

	public static int ocorrenciasDe(String palavra, String texto) {
		int ocorrencia = 0;
		StringTokenizer string = new StringTokenizer(texto);
		while ( string.hasMoreTokens() )
			if ( string.nextToken().equalsIgnoreCase(palavra) )
				ocorrencia++;
		return ocorrencia;
	}
}
